<?php

// Main Class
require_once 'core.php';

Class WpAutomaticItunes extends wp_automatic{


/*
 * ---* youtube get links ---
 */
function Itunes_fetch_items($keyword, $camp) {

	echo "<br>so I should now get some items from Itunes" ;
 
	// ini options
	$camp_opt = unserialize ( $camp->camp_options );
	if( stristr($camp->camp_general, 'a:') ) $camp->camp_general=base64_encode($camp->camp_general);
	$camp_general = unserialize ( base64_decode( $camp->camp_general ) );
	$camp_general=array_map('stripslashes', $camp_general);
	
	// media
	$cg_iu_media = $camp_general['cg_iu_media'];
	
	// items url
	$itunesSearchUrl = "https://itunes.apple.com/search?term=". urlencode(trim($keyword)) ."&media=$cg_iu_media" ;
	
	// Attribute
	$cg_iu_attribute = $camp_general['cg_iu_attribute'];
	
	if(trim($cg_iu_attribute) != '' && trim($cg_iu_attribute) != 'All' ){
		$itunesSearchUrl .= '&attribute='.$cg_iu_attribute;
	}

 	// get start-index for this keyword
	$query = "select keyword_start ,keyword_id from {$this->wp_prefix}automatic_keywords where keyword_name='$keyword' and keyword_camp={$camp->camp_id}";
	$rows = $this->db->get_results ( $query );
	@$row = $rows [0];
	
	//If no rows add a keyword record
	if(count($rows) == 0){
		$query="insert into {$this->wp_prefix}automatic_keywords(keyword_name,keyword_camp,keyword_start) values ('$keyword','{$camp->camp_id}',1)";
		$this->db->query($query);
		$kid = $this->db->insert_id;
		$start = 0;
		
	}else{
		$kid = $row->keyword_id;
		$start = $row->keyword_start;
	}
	
	$itunesSearchUrl.= '&offset=' .$start;
	
	echo '<br>ItunesUrl:'.$itunesSearchUrl;

	if ($start == - 1) {
		echo '<- exhausted link';
			
		if( ! in_array( 'OPT_IU_CACHE' , $camp_opt )){
			$start =0;
			echo '<br>Cache disabled resetting index to 0';
		}else{

			//check if it is reactivated or still deactivated
			if($this->is_deactivated($camp->camp_id, $keyword)){
				$start =0;
			}else{
				//still deactivated
				return false;
			}

		}
			
			
	}
	 
	echo ' index:' . $start;

	// update start index to start+1
	$nextstart = $start + 50;

	$query = "update {$this->wp_prefix}automatic_keywords set keyword_start = $nextstart where keyword_id=$kid ";
	$this->db->query ( $query );

	// get items
	// curl get
	$x = 'error';
	$url = $itunesSearchUrl;
	curl_setopt ( $this->ch, CURLOPT_HTTPGET, 1 );
	curl_setopt ( $this->ch, CURLOPT_URL, trim ( $url ) );
	$exec = curl_exec ( $this->ch );
	$x = curl_error ( $this->ch );
	
	
	// error check
	if(trim($x) != ''){
		echo '<br>Curl error:'.$x;
		return false;
	} 
	
	// validate reply
	if( ! stristr($exec, 'resultCount')){
		echo '<br>Not expected response from Itunes';
	} 
	
	$jsonReply = json_decode($exec);
	
	$allItms = $jsonReply->results;
	
	// Check returned items count
 	if ( count($allItms) > 0 ) {

		echo '<br>Valid reply returned with ' . count($allItms) . ' item';

	} else {
		
		echo '<br>No items found';
		 
		echo '<br>Keyword have no more images deactivating...';
		$query = "update {$this->wp_prefix}automatic_keywords set keyword_start = -1 where keyword_id=$kid ";
		$this->db->query ( $query );
				
		$this->deactivate_key($camp->camp_id, $keyword);
				
	}
	 
 
	echo '<ol>';

	foreach ( $allItms as $item ) {
		 
		$item_link = $item->trackViewUrl;
		$id = $item->trackId;

		if( $this->is_execluded($camp->camp_id, $item_link) ){
			echo '<-- Execluded';
			continue;
		}
		
		echo '<li> Link:'.$item_link;

		if ( ! $this->is_duplicate($item_link) )  {
			
			$data = ( base64_encode( serialize ( $item ) ) );
			
			$query = "INSERT INTO {$this->wp_prefix}automatic_general ( item_id , item_status , item_data ,item_type) values (  '$id', '0', '$data' ,'iu_{$camp->camp_id}_$keyword')  ";
			$this->db->query ( $query );
			
		} else {
			echo ' <- duplicated <a href="'.get_edit_post_link($this->duplicate_id).'">#'.$this->duplicate_id.'</a>';
		}
			
	}

	echo '</ol>';

}
	
 	
/*
 * ---* Itunes post ---
 */
function Itunes_get_post($camp) {

	 
	// Campaign options
	$camp_opt = unserialize (  $camp->camp_options );
	$keywords = explode ( ',', $camp->camp_keywords );
 	
	foreach ( $keywords as $keyword ) {
			
		$keyword = trim($keyword);

		//update last keyword
		update_post_meta($camp->camp_id, 'last_keyword', trim($keyword));
			
		if (trim ( $keyword ) != '') {

			// getting links from the db for that keyword
			$query = "select * from {$this->wp_prefix}automatic_general where item_type=  'iu_{$camp->camp_id}_$keyword' and item_status ='0'";
			$this->used_keyword=$keyword;
			$res = $this->db->get_results ( $query );

			// when no links lets get new links
			if (count ( $res ) == 0) {

				// get new fresh items
				$this->Itunes_fetch_items ( $keyword, $camp );
				
				// getting links from the db for that keyword
				$res = $this->db->get_results ( $query );
			}

			 			
			//check if already duplicated
			//deleting duplicated items
			$res_count = count($res);
			for($i=0;$i< $res_count ;$i++){

				$t_row = $res[$i];
					
				$t_data =  unserialize ( base64_decode( $t_row->item_data ) );
				 
				$t_link_url= $t_data->trackViewUrl ;
				$t_row->item_id = $t_row->trackId;

				if( $this->is_duplicate($t_link_url) ){
						
					//duplicated item let's delete
					unset($res[$i]);
						
					echo '<br>Itunes item ('. $t_data ->trackViewUrl .') found cached but duplicated <a href="'.get_permalink($this->duplicate_id).'">#'.$this->duplicate_id.'</a>'  ;
						
					//delete the item
					$query = "delete from {$this->wp_prefix}automatic_general where item_id='{$t_row->item_id}' and item_type=  'iu_{$camp->camp_id}_$keyword'";
					$this->db->query ( $query );
						
				}else{
					break;
				}

			}

			// check again if valid links found for that keyword otherwise skip it
			if (count ( $res ) > 0) {
					
				// lets process that link
				$ret = $res [$i];
					
				$data = unserialize ( base64_decode( $ret->item_data )  );
				
				$temp = $data;
				 	
				echo '<br>Found Link:'.$temp->trackViewUrl;
				
				// update the link status to 1
				$query = "update {$this->wp_prefix}automatic_general set item_status='1' where item_id='$ret->item_id' and item_type='iu_{$camp->camp_id}_$keyword' ";
					
				$this->db->query ( $query );
					
				// if cache not active let's delete the cached videos and reset indexes
				if (! in_array ( 'OPT_IU_CACHE', $camp_opt )) {
					echo '<br>Cache disabled claring cache ...';
					$query = "delete from {$this->wp_prefix}automatic_general where item_type='iu_{$camp->camp_id}_$keyword' and item_status ='0'";
					$this->db->query ( $query );

					// reset index
					$query = "update {$this->wp_prefix}automatic_keywords set keyword_start =1 where keyword_camp={$camp->camp_id}";
					$this->db->query ( $query );
					
				}

				return $temp;
				
			} else {
					
				echo '<br>No links found for this keyword';
			}
		} // if trim
	} // foreach keyword
}

}